package ui.view;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import java.util.LinkedList;

import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import classes.CpsObject;
import classes.HolonObject;
import ui.model.*;

class MyCanvas extends JPanel implements MouseListener, MouseMotionListener {
	private Image img = null; // Contains the image to draw on MyCanvas
	private int x = 0;
	private int y = 0;
	Model model;
	
	boolean dragging = false;
	boolean dropDelete = false;
	CpsObject tempCps = null;

	// PopUpMenu
	JPopupMenu popmenu = new JPopupMenu();
	JMenuItem itemDelete = new JMenuItem("Delete Object");

	public MyCanvas(Model model) {
		this.model = model;
		popmenu.add(itemDelete);
		itemDelete.setEnabled(false);
		itemDelete.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				model.getObjectsOnCanvas().remove(tempCps);
				repaint();
			}
		});
		img = new ImageIcon(this.getClass().getResource("/Images/Dummy_House.png")).getImage().getScaledInstance(30, 30,
				java.awt.Image.SCALE_SMOOTH);

		this.addMouseListener(this);
		this.addMouseMotionListener(this);
	}

	public void paintComponent(Graphics g) {
		// Draws the image to the canvas
		super.paintComponent(g);
		for (CpsObject cps : model.getObjectsOnCanvas()) {
			g.drawImage(img, cps.getPos().x, cps.getPos().y, null);
		}
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		x = e.getX();
		y = e.getY();
		dropDelete = false;
		for (CpsObject cps : model.getObjectsOnCanvas()) {
			int cx = cps.getPos().x;
			int cy = cps.getPos().y;
			if (x - img.getWidth(null) <= cx && y - img.getHeight(null) <= cy && x + img.getWidth(null) >= cx
					&& y + img.getHeight(null) >= cy) {
				tempCps = cps;
				if (e.getButton() == e.BUTTON1) {
					dragging = true;
				} else {
					dropDelete = true;
				}
			}
		}
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		if (dragging) {
			x = e.getX();
			y = e.getY();
			dragging = false;
			tempCps.setPos(e.getX() - 15, e.getY() - 15);
			tempCps = null;
			repaint();
		}
		// Rechtsklick Liste
		if (e.getButton() == e.BUTTON3) {
			if (dropDelete)itemDelete.setEnabled(true);
			popmenu.show(e.getComponent(), e.getX(), e.getY());

		}
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		if (dragging) {
			tempCps.setPos(e.getX() - 15, e.getY() - 15);
			repaint();
			System.out.println("drag: " + e.getX() + " " + e.getY());
		}
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		// TODO Auto-generated method stub

	}
}